let data = {
    usePassword: false,
    policyRead: false,
    counting: 0,
    loginNumber: "",
    loginCode: ""
}

// NA function
// readPolicy()
// sendVCode(string: {type, number}); callback(string: "0": success, other: "fail"}
// login(string: { value, password/code }; callback(string: "0": success, other: "fail"}

function onPolicyClick(e) {
    postToNA("readPolicy");
}

function onAgreementClick(e) {
    postToNA("readAgreement")
}

function onLoginClick(e) {
    if (!data.policyRead) {
        alert("请阅读并勾选隐私政策、用户协议");
        return;
    }

    let loginNumber = data.loginNumber;
    let loginCode = data.loginCode;
    if (!checkLoginNumberValid()) {
        alert("请检查手机号、邮箱地址格式是否正确");
        return;
    }
    if (!checkLoginCodeValid()) {
        alert(data.usePassword ? "密码至少应为6位字符" : "验证码应为6位数字");
        return;
    }

    let param = { value: loginNumber };
    if (data.usePassword) {
        param.password = loginCode;
    } else {
        param.code = loginCode;
    }

    postToNA("login", JSON.stringify(param), function (res) {
        if (res != "0") {
            alert(res || "网络异常，请重试");
        }
    });
}

function onReadPolicyClick(e) {
    data.policyRead = !data.policyRead;
}

function onChangeLoginStyleClick(e) {
    data.usePassword = !data.usePassword;
}

function onLoginNumberChanged(e) {
    let loginNumber = e.target.value;
    data.loginNumber = loginNumber;
}

function onLoginCodeChanged(e) {
    let loginCode = e.target.value;
    data.loginCode = loginCode;
}

let requestingCode = false;
function onSendCodeClick(e) {
    if (!checkLoginNumberValid()) {
        alert("手机号或邮箱地址格式不正确");
        return;
    }
    if (requestingCode) {
        alert("发送中，请稍后");
        return;
    }
    if (data.counting != 0) return;

    let isPhoneNumber = checkLoginNumberIsPhoneNumber();

    let postData = {type: isPhoneNumber ? "phone" : "email", number: data.loginNumber};
    requestingCode = true;
    postToNA("sendVCode", JSON.stringify(postData), function (res) {
        requestingCode = false;
        if (res == "0") { // success

            let curTime = new Date().getTime() / 1000;
            let id = setInterval(function () {
                let newTime = new Date().getTime() / 1000;
                let passedSec = parseInt(newTime - curTime);
                let showSec = 60 - passedSec;
                if (showSec < 0) {
                    clearInterval(id);
                    data.counting = 0;
                } else {
                    data.counting = showSec;
                }
            }, 1000);

        } else { // fail
            alert(res || "发送失败，请稍后重试");
        }
    })

}

function checkLoginNumberIsPhoneNumber() {
    let phoneReg = /^[1][0-9]{10}$/;
    return phoneReg.test(data.loginNumber);
}

function checkLoginNumberIsEmail () {
    let emailReg = /^.+@.+\..+$/;
    return emailReg.test(data.loginNumber);
  }


function checkLoginNumberValid() {
    let isPhoneNumber = checkLoginNumberIsPhoneNumber();
    if (isPhoneNumber) {
      return true;
    }
    let isEmail = checkLoginNumberIsEmail();
    return isEmail;
}

function checkLoginCodeValid() {
    return data.loginCode.length >= 6;
}

let app;

function onLoad() {

    app = new Vue({
        el: '#app',
        data: {
            data: data
        },
        methods: {
            onReadPolicyClick: onReadPolicyClick,
            onChangeLoginStyleClick: onChangeLoginStyleClick,
            onSendCodeClick: onSendCodeClick,
            onPolicyClick: onPolicyClick,
            onAgreementClick: onAgreementClick,
            onLoginClick: onLoginClick,
            onLoginNumberChanged: onLoginNumberChanged,
            onLoginCodeChanged: onLoginCodeChanged
        }
    });
}